%define rolluppatch   20110108
%define patchdate     20110108
%define version       5.9
%define release       %mkrel 10
%define major         5
%define majorminor    5.9
%define utf8libname   %mklibname %{name}w %{major}
%define libname       %mklibname %{name} %{major}
%define develname     %mklibname -d %{name}
%define utf8develname %mklibname -d %{name}w

Summary:	A CRT screen handling and optimization package
Name:		ncurses
Version:	%{version}
Release:	%{release}
License:	MIT
Group:		System/Libraries
Url:		http://www.gnu.org/software/ncurses/ncurses.html
Source0:	ftp://ftp.gnu.org/gnu/ncurses/%{name}-%{version}.tar.gz
Source4:	ncurses-resetall.sh
Source5:    	ncurses-usefull-terms
# fwang: Source 100 is rollup patches from
# ftp://invisible-island.net/ncurses/5.9/
#Source100:	ncurses-%{version}-%{rolluppatch}-patch.sh.bz2
Patch1:		ncurses-5.6-xterm-debian.patch
Patch2:		ncurses-5.9-20111224-patch.sh.bz2
Patch3:		ncurses-5.9-20111231-20120204.patch.bz2
#to support rxvt-unicode 256 colors (bug 6835)
Patch7:		ncurses-5.9-urxvt.patch
# Patch >100 from here:
# ftp://invisible-island.net/ncurses/5.7/
BuildRequires:	gpm-devel
BuildRequires:	sharutils
Conflicts:	%{name}-extraterms < 5.6-1.20070721.1

%description
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

%package -n %{libname}
Summary:	The development files for applications which use ncurses
Group:		System/Libraries
Requires(pre):	filesystem >= 2.1.9-18
Requires:	ncurses = %{version}-%{release}

%description -n %{libname}
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

%package -n %{utf8libname}
Summary:	Ncurses libraries which support UTF8
Group:		System/Libraries
Requires(pre):	filesystem >= 2.1.9-18
Requires:	ncurses = %{version}-%{release}

%description -n %{utf8libname}
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

This package contains ncurses libraries which support wide char (UTF8),
and is not compatible with those without.

%package extraterms
Summary:	Some exotic terminal descriptions
Group:		System/Libraries
Requires:	ncurses = %{version}-%{release}

%description extraterms
Install the ncurses-extraterms package if you use some exotic terminals.

%package -n %{develname}
Summary:	The development files for applications which use ncurses
Group:		Development/C
Requires(pre):	filesystem >= 2.1.9-18
Requires:	%{libname} = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%mklibname -d %name 5

%description -n %{develname}
The header files and libraries for developing applications that use
the ncurses CRT screen handling and optimization package.

Install the ncurses-devel package if you want to develop applications
which will use ncurses.

%package -n %{utf8develname}
Summary:	The development files for applications which use ncurses
Group:		Development/C
Requires(pre):	filesystem >= 2.1.9-18
Requires:	%{utf8libname} = %{version}-%{release}
Provides:	lib%{name}w-devel = %{version}-%{release}
Provides:	ncursesw-devel = %{version}-%{release}
Obsoletes:	%mklibname -d %{name}w 5
Conflicts:	%{_lib}ncurses-devel < 5.7-3.20091128.2

%description -n	%{utf8develname}
The libraries for developing applications that use ncurses CRT screen
handling and optimization package. Install it if you want to develop
applications which will use ncurses.

Note that the libraries included here supports wide char (UTF-8),
and is not compatible with those without. When linking programs with
these libraries, you will have to append a "w" to the library names,
i.e. -lformw, -lmenuw, -lncursesw, -lpanelw.

%prep
%setup -q

# Let's apply rollup patches at first
#bunzip2 -kc %SOURCE100 >./ncurses-%{version}-%{rolluppatch}-patch.sh
#/bin/sh ncurses-%{version}-%{rolluppatch}-patch.sh
# Then the official patch

%patch2 -p1 -b .update
%patch3 -p1 -b .update2
%patch7 -p1 -b .urxvt

# regenerating configure needs patched autoconf, so modify configure
# directly
%patch1 -p1 -b .deb

find . -name "*.orig" | xargs rm -f
# fix some permissions
chmod 755 c++/edit_cfg.sh test/listused.sh test/configure test/tracemunch

%build
export PKG_CONFIG_LIBDIR=%{_libdir}/pkgconfig

mkdir -p ncurses-normal
pushd ncurses-normal
CONFIGURE_TOP=.. 
%configure2_5x \
	--includedir=%{_includedir}/ncurses \
	--without-libtool \
	--with-shared \
	--with-normal \
	--without-debug \
	--enable-overwrite \
	--without-profile \
	--with-gpm \
	--enable-termcap \
	--enable-getcap \
	--enable-const \
	--enable-hard-tabs \
	--enable-hash-map \
	--enable-no-padding \
	--enable-sigwinch \
	--without-ada \
	--disable-widec \
	--enable-xmc-glitch \
	--enable-colorfgbg \
	--enable-pc-files \
	--with-pkg-config-libdir=%{_libdir}/pkgconfig \
	 --with-chtype=long \
	--with-ospeed=unsigned

%make -j1
popd

mkdir -p ncurses-utf8
pushd ncurses-utf8
CONFIGURE_TOP=.. 
%configure2_5x \
	--includedir=%{_includedir}/ncursesw \
	--without-libtool \
	--with-shared \
	--with-normal \
	--without-debug \
	--enable-overwrite \
	--without-profile \
	--with-gpm \
	--enable-termcap \
	--enable-getcap \
	--enable-const \
	--enable-hard-tabs \
	--enable-hash-map \
	--enable-no-padding \
	--enable-sigwinch \
	--without-ada \
	--enable-widec \
	--enable-xmc-glitch \
	--enable-colorfgbg \
	--enable-pc-files \
	--with-pkg-config-libdir=%{_libdir}/pkgconfig \
	 --with-chtype=long \
	--with-ospeed=unsigned

%make -j1
popd

%install
rm -rf %{buildroot}

pushd ncurses-utf8
%{makeinstall_std}
popd

pushd ncurses-normal
%{makeinstall_std}
popd

ln -sf ../l/linux %{buildroot}%{_datadir}/terminfo/c/console
ln -sf ncurses/curses.h %{buildroot}/usr/include/ncurses.h
for I in curses unctrl eti form menu panel term; do
	ln -sf ncurses/$I.h %{buildroot}/usr/include/$I.h
done

# the resetall script
install -m 755 %{SOURCE4} %{buildroot}%{_bindir}/resetall
# we don't want this in doc
rm -f c++/demo

#
# FIXME
# OK do not time to debbug it now
#
cp %{buildroot}%{_datadir}/terminfo/x/xterm %{buildroot}%{_datadir}/terminfo/x/xterm2
cp %{buildroot}%{_datadir}/terminfo/x/xterm-new %{buildroot}%{_datadir}/terminfo/x/xterm

#
# remove unneeded/unwanted files
# have to be done before find commands below
#
rm -f %{buildroot}%{_libdir}/terminfo

# fwang: avoid conflict with kon package
rm -f %{buildroot}%{_datadir}/terminfo/k/kon

#
# FIXME
#
(cd %{buildroot} ; find usr/share/terminfo      -type d | perl -pe 's||%%dir /|') > %{name}.list
(cd %{buildroot} ; find usr/share/terminfo -not -type d | perl -pe 's||/|')       > %{name}-extraterms.list
perl -pe 's||%{_datadir}/terminfo/|' %{SOURCE5} >> %{name}.list

perl -ni -e 'BEGIN { open F, "%{name}.list"; /^%/ or $s{$_} = 1 foreach <F>; } print unless $s{$_}' %{name}-extraterms.list

find %{buildroot}/%{_libdir} -name 'lib*.a' -not -type d -not -name "*_g.a" -not -name "*_p.a" -not -name "*w.a" | sed -e "s#^%{buildroot}##" > %{libname}-devel.list

%multiarch_includes %{buildroot}%{_includedir}/ncurses/curses.h

%multiarch_includes %{buildroot}%{_includedir}/ncursesw/curses.h

%files -f %{name}.list
%defattr(-,root,root)
%doc README ANNOUNCE
%{_datadir}/tabset
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*

%files -n %{libname}
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/libform.so.*
%attr(755,root,root) %{_libdir}/libmenu.so.*
%attr(755,root,root) %{_libdir}/libncurses.so.*
%attr(755,root,root) %{_libdir}/libpanel.so.*

%files -n %{utf8libname}
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/lib*w.so.*

%files extraterms -f %{name}-extraterms.list
%defattr(-,root,root)
%doc README

%files -n %{develname}
%defattr(-,root,root)
%doc doc c++ test
%{_libdir}/libcurses.a
%{_libdir}/libcurses.so
%{_libdir}/libform.a
%{_libdir}/libform.so
%{_libdir}/libmenu.a
%{_libdir}/libmenu.so
%{_libdir}/libncurses++.a
%{_libdir}/libncurses.a
%{_libdir}/libncurses.so
%{_libdir}/libpanel.a
%{_libdir}/libpanel.so
%{_libdir}/pkgconfig/form.pc
%{_libdir}/pkgconfig/menu.pc
%{_libdir}/pkgconfig/ncurses++.pc
%{_libdir}/pkgconfig/ncurses.pc
%{_libdir}/pkgconfig/panel.pc
%{_includedir}/ncurses
%multiarch %{multiarch_includedir}/ncurses
%{_includedir}/*.h
%{_mandir}/man3/*

%files -n %{utf8develname}
%defattr(-,root,root)
%{_includedir}/ncursesw
%{_libdir}/pkgconfig/*w.pc
%multiarch %{multiarch_includedir}/ncursesw
%{_libdir}/lib*w.so
%{_libdir}/lib*w.a


%changelog

* Sat Jan 12 2013 umeabot <umeabot> 5.9-10.mga3
+ Revision: 360845
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Sep 01 2012 tv <tv> 5.9-9.mga3
+ Revision: 286789
- build with --with-chtype=long (mga#7235)

* Wed Aug 29 2012 eatdirt <eatdirt> 5.9-8.mga3
+ Revision: 285363
- Adding support for rxvt-unicode-256

* Sat Jul 21 2012 colin <colin> 5.9-7.mga3
+ Revision: 273158
- Update for usrmove

* Sat Apr 28 2012 colin <colin> 5.9-6.mga2
+ Revision: 234096
- Fix pkgconfig file location
- Move libncursesw to / from /usr (mga#4372)

  + tv <tv>
    - drop patch 4 (uneeded, SEGV was due to ncurses vs ncursesw)
    - silent fix patch
    - update to patch 20120204
    - patch 4: try to fix drakx installer segfault

* Tue Mar 06 2012 tv <tv> 5.9-3.mga2
+ Revision: 220176
- update to patch 20110716

* Fri Jul 01 2011 fwang <fwang> 5.9-2.mga2
+ Revision: 117116
- new version 5.9

* Sat Jan 08 2011 blino <blino> 5.7-6.20100925.1.mga1
+ Revision: 843
- remove old ldconfig scriptlets
- imported package ncurses

